/*
    Leksicki analizator za iskazne formule
    dozvoljeni znaci:
    sve vrste zagrada - ( [ { } ] ) (mogu se proizvoljno uprativati)
    operatori: iff, and, then, or, not
    iskazna slova: pocinje slovom ili _ iza toga slovo, _ ili cifre
		   vazi prvih MAX_SLOVA znaka
		   razlikuju se mala i velika slova
    zavrsava se tackom
*/

%{
#include <string.h>
#include <stdlib.h>
#include "main.h"
#include "y.tab.h"

void _preskoci( void );
%}

DIGIT           [0-9]
LETTER          [a-zA-Z_]

%%


"iff"                   { strcpy( yytext_p, yytext ); return (O_IFF); }
"and"                   { strcpy( yytext_p, yytext ); return (O_AND); }
"then"                  { strcpy( yytext_p, yytext ); return (O_IF); }
"or"                    { strcpy( yytext_p, yytext ); return (O_OR); }
"not"                   { strcpy( yytext_p, yytext ); return (O_NOT); }


{LETTER}({LETTER}|{DIGIT})*   {
                         if( yyleng > MAX_SLOVA )  yytext[ MAX_SLOVA ] = 0 ;
                         strcpy( yytext_p, yytext );
                         yylval.ivalue = _kako_je_kodirano( yytext );
                         return( T_ISKAZNO_SLOVO );
                        }


\(                      { strcpy( yytext_p, yytext ); return( L_ZAGRADA ); }
\[                      { strcpy( yytext_p, yytext ); return( L_ZAGRADA ); }
\{                      { strcpy( yytext_p, yytext ); return( L_ZAGRADA ); }
\)                      { strcpy( yytext_p, yytext ); return( D_ZAGRADA ); }
\]                      { strcpy( yytext_p, yytext ); return( D_ZAGRADA ); }
\}                      { strcpy( yytext_p, yytext ); return( D_ZAGRADA ); }
\.                      { strcpy( yytext_p, yytext ); return *yytext; }
\n                      { yyline++; }

"/*"                    { _preskoci();    /* komentar */ }

[ \t\n]                   { /* preskoci beline */}


.                       { 
                            _poruka (2, yyline, yytext[0]);
                            exit( 0 );
                        }                   

%%
int yywrap ()
{
	return 1;
}

void _preskoci()
{
 while( 1 ) {
        while( input() != '*' );
        if( input( ) != '/' ) unput( yytext[ yyleng - 1 ] );
        else return ;
 }
}

