
%{
#include <stdlib.h>
#include "main.h"

int yylex( void );

%}

/* ---------------------------------------------------------------------- */

%union
{
    int ivalue;     /* pozicija u tabeli iskaznog slova */
    struct cvor * drvo;
}

             /* Tokeni */
%token <ivalue> T_ISKAZNO_SLOVO
%token L_ZAGRADA
%token D_ZAGRADA

            /* Operatori */
%left O_IFF  
%left O_IF
%left O_OR 
%left O_AND
%left O_NOT

            /* Konstrukcije */
%type <drvo> formula, iskazna_formula


%%
/* ---------------------------------------------------------------------- */

formula : iskazna_formula '.'
{
    drvo_formule = $1;
    _oslobodi_tabelu_is ( );    /* oslobodi memoriju iz tabela isk. slova */
};

iskazna_formula : L_ZAGRADA iskazna_formula D_ZAGRADA
{
    $$ = $2;

};

iskazna_formula : iskazna_formula O_AND iskazna_formula
{
    $$ = alloc_mem (sizeof( struct cvor ));
    $$->tip = AND;
    $$->levi = $1;
    $$->desni = $3;
};

iskazna_formula : iskazna_formula O_IFF iskazna_formula
{
    $$ = alloc_mem (sizeof( struct cvor ));
    $$->tip = IFF;
    $$->levi = $1;
    $$->desni = $3;
};

iskazna_formula : iskazna_formula O_IF iskazna_formula
{
    $$ = alloc_mem (sizeof( struct cvor ));
    $$->tip = THEN;
    $$->levi = $1;
    $$->desni = $3;
};

iskazna_formula : iskazna_formula O_OR iskazna_formula
{
    $$ = alloc_mem (sizeof( struct cvor ));
    $$->tip = OR;
    $$->levi = $1;
    $$->desni = $3;
};

iskazna_formula : O_NOT iskazna_formula
{
    $$ = alloc_mem (sizeof( struct cvor ));
    $$->tip = NOT;
    $$->desni = $2;
    $$->levi = NULL;
};

iskazna_formula : T_ISKAZNO_SLOVO
{
    $$ = alloc_mem ( sizeof( struct cvor )) ;
    $$->tip = ISKAZNO_SLOVO ;
    $$->vrednost = $1 ;
    $$->desni = NULL;
    $$->levi = NULL;
};


%%
/* ---------------------------------------------------------------------- */

int yyerror (char *s)
{
    _poruka( 1, yyline, yytext_p );
    exit( 0 );
}







