/*
   Stampanje poruka.

   sadrzi f-je :  _poruka(int brojpor, arg ... )

   _poruka treba da ispisuje tekst poruke ciji se broj dobija kao
   argument uz eventualan ispis argumenata koji se navedu kao argumenti.

*/

#include <stdarg.h>
#include <string.h>
#include "main.h"
#include "poruke.h"


static char  s[8172];
static  char spom[8172];         /* pomocni upis brojnog argumenta i niza */

int  _poruka (int por, ...)
{
  char *c    ;                  /* pokazivac na poruku */
  char *c1   ;                  /* tekstualni argument */
  char ch    ;                  /* znak poruke */
  int  j     ;                  /* brojac znaka u poruci */
  int  stn   ;                  /* stanje u kom je automat */
  int  k     ;                  /* broj blankova iz !, ili duzina niza */
  int  broj_znaka;              /* ukupan broj znaka formirane poruke */
  int *nizi;                    /* pokazivac na niz integer-a */
  long *nizl;                   /* pokazivac na niz long */
  int i, l; 
  va_list a ;


  va_start ( a,por ) ;

  c = message[ por ];      /* pokazivac na poruku */

  j = 0 ;                       /* znak poruke */
  broj_znaka = 0;               /* broj znaka u formiranoj poruci */
  stn = 0 ;
  spom[0] = s[0] = '\0';

  while ( (ch = c[j++]) )
  {
   switch ( stn )
   {
    case 0 : if ( ch == KZNAK )
              stn = 1 ;
             else
             {
              s[broj_znaka++] = ch;
              s[broj_znaka] = 0;
             }
             break ;

    case 1 :
     switch ( ch )
     {
      case KZNAK : s[broj_znaka++] = KZNAK;  /* sam kontr. znak */
                   s[broj_znaka] = 0;
                   stn = 0 ;
                   break ;

      case NRED  : s[broj_znaka++] = CR;     /* novi red */
                   s[broj_znaka] = 0;
                   stn = 0 ;
                   break ;

      case NTB   : s[broj_znaka++] = TAB;    /* tabulacija */
                   s[broj_znaka] = 0;
                   stn = 0 ;
                   break ;

#if 0 
      case TIME  : time ( &ltime ) ;       /* tekuci datum i vreme */
                   broj_znaka+= strlen(c1=ctime(&ltime));
                   strcat(s, c1) ;
                   stn = 0 ;
                   break ;
#endif

      case blnk  :                     /* k blankova */
      case BLNK  :
                   k = va_arg ( a, int) ; /* ucitava se broj */
                   while ( k-- > 0 )
                     s[broj_znaka++] = ' ';
                   stn = 0 ;
                   s[broj_znaka] = 0;
                   break ;

      case 'A'   :                      /* ascii niska */
      case 'a'   : stn = 2 ;
                   break ;

      case 'S'   :                      /* ceo broj */
      case 's'   : stn = 3 ;
                   break ;
      case 'N'   :                     /* niz int, ili long */
      case 'n'   : stn = 4;
                   break;

      default    : return ( GRESKA ) ;
     } /* switch ch */

     break ;

    case 2 : if (( ch == 'S' ) || ( ch == 's' ))
             {
              broj_znaka+=strlen(c1=(char *)va_arg ( a, char *)) ;
              strcat(s,c1);
              stn = 0 ;
              break ;
             }

             return ( GRESKA ) ;

    case 3 :
     switch ( ch )
     {                         /* long int */
      case  'L' :
      case  'l' :
             sprintf (spom,"%ld", va_arg (a,long));
             broj_znaka += strlen(spom);
             strcat(s,spom);
             stn = 0 ;
             break ;
                               /* int */
      case  'W' :
      case  'w' :
             sprintf(spom,"%d",va_arg(a,int));
             broj_znaka += strlen(spom);
             strcat(s,spom);
             stn = 0 ;
             break ;
                               /* short */
      case  'C' :
      case  'c' :
             s[broj_znaka++] = va_arg ( a, int ) ;
             stn = 0 ;
             break ;
                               /* float */
      case  'F' :
      case  'f' :
             sprintf(spom,"%f",va_arg(a,double));
             broj_znaka += strlen(spom);
             strcat(s,spom);
             stn = 0 ;
             break ;

                               /* double float */
      case  'G' :
      case  'g' :
             sprintf ( spom ,"%f" , va_arg( a, double )) ;
             broj_znaka += strlen(spom);
             strcat(s,spom);
             stn = 0 ;
             break ;

      default : return ( GRESKA ) ;
     } /* switch ch */

     break ;

    case 4 :
     switch ( ch )
     {                         /* long int */
      case  'L' :
      case  'l' :
             k = va_arg ( a, int) ;       /* ucitava se duzina niza */
             nizl = va_arg ( a, long *);       /* pokazivac na niz */
             i = l = 0;
             while ( k > l ) {
              sprintf ( spom+i ,"%ld " , nizl[l++]) ;
              i = strlen(spom);
             }
             broj_znaka += strlen(spom);
             strcat(s,spom);
             s[broj_znaka] = 0;
             stn = 0 ;
             break ;
                               /* int */
      case  'W' :
      case  'w' :
             k = va_arg ( a, int) ;       /* ucitava se duzina niza */
             nizi = va_arg ( a, int *);       /* pokazivac na niz */
             i = l = 0;
             while ( k > l ) {
              sprintf ( spom+i ,"%d " , nizi[l++]) ;
              i = strlen(spom);
             }
             broj_znaka += strlen(spom);
             strcat(s,spom);
             s[broj_znaka] = 0;
             stn = 0 ;
             break ;

      default : return ( GRESKA ) ;
     } /* switch ch */

    break ;
   } /* switch stn */
  }  /* while */

s[broj_znaka] = 0;

/* if (tofile)  fprintf (out_prover,"%s",s); */
printf ("%s", s);

va_end(a);

return( OK );
}  /* _poruka */
